Index: branches/libIGCM/ORCA2_LIM_PISCES/IGCM00/COMP/opa9.card
===================================================================
--- branches/libIGCM/ORCA2_LIM_PISCES/IGCM00/COMP/opa9.card	(revision 1396)
+++ branches/libIGCM/ORCA2_LIM_PISCES/IGCM00/COMP/opa9.card	(revision 1631)
@@ -4,8 +4,34 @@
 [UserChoices]
 OPA_NDT_DAY=15
-#============================
-#--v3, v3_1
+#==============================================================
+#-- Name of directory for COMMON ACCOUNT at idris or CCRT
+#-- available directories are:  v3, v3_1
+#-- related to NEMO_tag_revision (nemo_v3, nemo_v3_1)
+#-- NOTE: if you use your own directory you have to comment it
 OPA_version=v3_1
-#============================
+#==============================================================
+
+#-- if you run interannual is "y", if not is "n"
+Interannual_Run=n
+
+[Interannual]
+#=====================================================================
+#-- Surface Boundary Condition original files name ( get by the job )
+#=====================================================================
+#-- NOTE: MANDATORY STRUCTURE OF FILE NAMES GET BY THE JOB : 
+#-- "basename_yyyy.nc"  	( for interannual data )
+#-- "basename.nc"	  	( for climatologycal data )
+#-- MANDATORY: NAMES USED IN List_jobsbc VARIABLE MUST BE ONLY THE BASENAME
+
+List_jobsbc=(taux_1m, tauy_1m, flx)
+
+#==========================================================================================
+#-- Surface Boundary Condition files name expected by NEMO ( same as the ones in namelist )
+#==========================================================================================
+#-- NOTE: 2 possible cases :
+#-- 1) put in List_runsbc file names different from List_jobsbc but identical to the ones in namelist
+#-- 2) leave List_runsbc empty so NEMO will read file names specified in List_jobsbc variable above
+
+List_runsbc=()
 
 [InitialStateFiles]
@@ -21,11 +47,8 @@
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/data_1m_potential_temperature_nomask.nc, .), \
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/data_1m_salinity_nomask.nc, .), \
-            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/flx.nc, .),\
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/geothermal_heating.nc, .),\
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/runoff_1m_nomask.nc, .),\
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/sss_data.nc, .),\
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/sst_data.nc, .),\
-            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/taux_1m.nc, .),\
-            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/tauy_1m.nc, .),\
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/subbasins.nc, .)
 
@@ -44,11 +67,9 @@
         (${PREFIX_NWRITE}_${DATE_OPA}_grid_V.nc, ${R_OUT_OCE_NWRITE}/${PREFIX}_${WF1}_grid_V.nc, Post_1M_grid_V),\
         (${PREFIX_NWRITE}_${DATE_OPA}_grid_W.nc, ${R_OUT_OCE_NWRITE}/${PREFIX}_${WF1}_grid_W.nc, Post_1M_grid_W),\
-        (${PREFIX_NWRITE}_${DATE_OPA}_diaptr.nc, ${R_OUT_OCE_NWRITE}/${PREFIX}_${WF1}_diaptr.nc, Post_1M_diaptr),\
-        (${PREFIX_NWRITE}_${DATE_OPA}_trends.nc, ${R_OUT_OCE_NWRITE}/${PREFIX}_${WF1}_trends.nc, NONE),\
-        (${PREFIX_NWRITE}_${DATE_OPA}_diagap.nc, ${R_OUT_OCE_NWRITE}/${PREFIX}_${WF1}_diagap.nc, NONE),\
         (damping.coeff.nc , ${R_OUT_OCE_NWRITE}/${PREFIX}_damping.coeff.nc, NONE),\
         (mesh_mask.nc     , ${R_OUT_OCE_O}/${config_UserChoices_JobName}_mesh_mask.nc, NONE),\
         (output.abort.nc  , ${R_OUT_OCE_D}/${PREFIX}_output.abort.nc, NONE),\
-        (output.init.nc   , ${R_OUT_OCE_O_I}/${config_UserChoices_JobName}_${PeriodDateBegin}_output.init.nc, NONE),\
+        (output.init.nc   , ${R_OUT_OCE_O_I}/${config_UserChoices_JobName}_${PeriodDateBegin}_output.init.nc, NONE)
+
 
 [Post_1M_grid_T]
@@ -71,7 +92,2 @@
 GatherWithInternal = (nav_lon, nav_lat, depthw, time_counter)
 TimeSeriesVars =
-
-[Post_1M_diaptr]
-Patches = ()
-GatherWithInternal = (lat, deptht, depthw, time_counter)
-TimeSeriesVars = (zotemglo, zosalglo, zomsfglo, zotematl, zosalatl, zomsfatl, zotempac, zosalpac, zomsfpac, zotemind, zosalind, zomsfind, zotemipc, zosalipc, zomsfipc, sohtatl, sostatl, sohtpac, sostpac, sohtind, sostind, sohtipc, sostipc, sophtadv, sophtove, sophtldf, sopstadv, sopstove, zomsfeiv, sophteiv, sopsteiv)