Index: trunk/CONFIG/GYRE/EXP00/iodef.xml
===================================================================
--- trunk/CONFIG/GYRE/EXP00/iodef.xml	(revision 1636)
+++ trunk/CONFIG/GYRE/EXP00/iodef.xml	(revision 1637)
@@ -122,5 +122,5 @@
     </file>
    
-    <file id="GYRE_5d_grid_U" description="ocean U grid variables" output_freq="432000" level="5" >
+    <file id="GYRE_5d_grid_U" description="ocean U grid variables" output_freq="432000" output_level="5" >
 	<field ref="uoce"         name="vozocrtx"  />
 	<field ref="uoce_eiv"     name="vozoeivu"  />
@@ -128,5 +128,5 @@
     </file>
   
-    <file id="GYRE_5d_grid_V" description="ocean V grid variables" output_freq="432000" level="5" >
+    <file id="GYRE_5d_grid_V" description="ocean V grid variables" output_freq="432000" output_level="5" >
 	<field ref="voce"         name="vomecrty"  />
 	<field ref="voce_eiv"     name="vomeeivv"  />
@@ -134,5 +134,5 @@
     </file>
  
-    <file id="GYRE_5d_grid_W" description="ocean W grid variables" output_freq="432000" level="5" >
+    <file id="GYRE_5d_grid_W" description="ocean W grid variables" output_freq="432000" output_level="5" >
 	<field ref="woce"         name="vovecrtz" />
 	<field ref="woce_eiv"     name="voveeivw" />
Index: trunk/CONFIG/GYRE_LOBSTER/EXP00/iodef.xml
===================================================================
--- trunk/CONFIG/GYRE_LOBSTER/EXP00/iodef.xml	(revision 1636)
+++ trunk/CONFIG/GYRE_LOBSTER/EXP00/iodef.xml	(revision 1637)
@@ -147,5 +147,5 @@
     </file>
    
-    <file id="GYREL_1m_grid_U" description="ocean U grid variables" output_freq="2592000" level="5" >
+    <file id="GYREL_1m_grid_U" description="ocean U grid variables" output_freq="2592000" output_level="5" >
 	<field ref="uoce"         name="vozocrtx"  />
 	<field ref="uoce_eiv"     name="vozoeivu"  />
@@ -153,5 +153,5 @@
     </file>
   
-    <file id="GYREL_1m_grid_V" description="ocean V grid variables" output_freq="2592000" level="5" >
+    <file id="GYREL_1m_grid_V" description="ocean V grid variables" output_freq="2592000" output_level="5" >
 	<field ref="voce"         name="vomecrty"  />
 	<field ref="voce_eiv"     name="vomeeivv"  />
@@ -159,5 +159,5 @@
     </file>
  
-    <file id="GYREL_1m_grid_W" description="ocean W grid variables" output_freq="2592000" level="5" >
+    <file id="GYREL_1m_grid_W" description="ocean W grid variables" output_freq="2592000" output_level="5" >
 	<field ref="woce"         name="vovecrtz" />
 	<field ref="woce_eiv"     name="voveeivw" />
@@ -171,5 +171,5 @@
     </file>
   
-    <file id="GYREL_1m_ptrc_T" description="lobster sms variables" output_freq="2592000" level="5" >
+    <file id="GYREL_1m_ptrc_T" description="lobster sms variables" output_freq="2592000" output_level="5" >
        <field ref="DET"      />
        <field ref="ZOO"      />
@@ -180,5 +180,5 @@
     </file>
 
-    <file id="GYREL_1m_diad_T" description="additional lobster diagnostics" output_freq="2592000" level="5" >  
+    <file id="GYREL_1m_diad_T" description="additional lobster diagnostics" output_freq="2592000" output_level="5" >  
        <field ref="FNO3PHY"   /> 
        <field ref="FNH4PHY"   /> 
Index: trunk/CONFIG/ORCA2_LIM/EXP00/iodef.xml
===================================================================
--- trunk/CONFIG/ORCA2_LIM/EXP00/iodef.xml	(revision 1636)
+++ trunk/CONFIG/ORCA2_LIM/EXP00/iodef.xml	(revision 1637)
@@ -159,5 +159,5 @@
       </file>
       
-      <file id="ORCA2_5d_grid_U" description="ocean U grid variables" output_freq="432000" level="5" >
+      <file id="ORCA2_5d_grid_U" description="ocean U grid variables" output_freq="432000" output_level="5" >
 	<field ref="uoce"         name="vozocrtx"  />
 	<field ref="uoce_eiv"     name="vozoeivu"  />
@@ -165,5 +165,5 @@
       </file>
       
-      <file id="ORCA2_5d_grid_V" description="ocean V grid variables" output_freq="432000" level="5" >
+      <file id="ORCA2_5d_grid_V" description="ocean V grid variables" output_freq="432000" output_level="5" >
 	<field ref="voce"         name="vomecrty"  />
 	<field ref="voce_eiv"     name="vomeeivv"  />
@@ -171,5 +171,5 @@
       </file>
       
-      <file id="ORCA2_5d_grid_W" description="ocean W grid variables" output_freq="432000" level="5" >
+      <file id="ORCA2_5d_grid_W" description="ocean W grid variables" output_freq="432000" output_level="5" >
 	<field ref="woce"         name="vovecrtz" />
 	<field ref="woce_eiv"     name="voveeivw" />
@@ -183,5 +183,5 @@
       </file>
       
-      <file id="ORCA2_5d_icemod" description="ice variables" output_freq="432000" level="5" >
+      <file id="ORCA2_5d_icemod" description="ice variables" output_freq="432000" output_level="5" >
 	<field ref="ice_pres"                     />
 	<field ref="snowthic_cea" name="isnowthi" />
Index: trunk/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml
===================================================================
--- trunk/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml	(revision 1636)
+++ trunk/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml	(revision 1637)
@@ -215,5 +215,5 @@
       </file>
       
-      <file id="ORCA2_5d_grid_U" description="ocean U grid variables" output_freq="432000" level="5" >
+      <file id="ORCA2_5d_grid_U" description="ocean U grid variables" output_freq="432000" output_level="5" >
 	<field ref="uoce"         name="vozocrtx"  />
 	<field ref="uoce_eiv"     name="vozoeivu"  />
@@ -221,5 +221,5 @@
       </file>
       
-      <file id="ORCA2_5d_grid_V" description="ocean V grid variables" output_freq="432000" level="5" >
+      <file id="ORCA2_5d_grid_V" description="ocean V grid variables" output_freq="432000" output_level="5" >
 	<field ref="voce"         name="vomecrty"  />
 	<field ref="voce_eiv"     name="vomeeivv"  />
@@ -227,5 +227,5 @@
       </file>
       
-      <file id="ORCA2_5d_grid_W" description="ocean W grid variables" output_freq="432000" level="5" >
+      <file id="ORCA2_5d_grid_W" description="ocean W grid variables" output_freq="432000" output_level="5" >
 	<field ref="woce"         name="vovecrtz" />
 	<field ref="woce_eiv"     name="voveeivw" />
@@ -239,5 +239,5 @@
       </file>
       
-      <file id="ORCA2_5d_icemod" description="ice variables" output_freq="432000" level="5" >
+      <file id="ORCA2_5d_icemod" description="ice variables" output_freq="432000" output_level="5" >
 	<field ref="ice_pres"                     />
 	<field ref="snowthic_cea" name="isnowthi" />
@@ -255,5 +255,5 @@
       </file>
 
-    <file id="ORCA2P_5d_ptrc_T" description="pisces sms variables" output_freq="432000" level="5" >
+    <file id="ORCA2P_5d_ptrc_T" description="pisces sms variables" output_freq="432000" output_level="5" >
        <field ref="DIC"      />
        <field ref="Alkalini" />
@@ -281,5 +281,5 @@
     </file>
 
-      <file id="ORCA2P_5d_diad_T" description="additional pisces diagnostics" output_freq="432000" level="5" >
+      <file id="ORCA2P_5d_diad_T" description="additional pisces diagnostics" output_freq="432000" output_level="5" >
        <field ref="PH"       />
        <field ref="CO3"      />
Index: trunk/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml
===================================================================
--- trunk/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml	(revision 1636)
+++ trunk/CONFIG/ORCA2_OFF_PISCES/EXP00/iodef.xml	(revision 1637)
@@ -94,5 +94,5 @@
     </file>
 
-    <file id="PISCES_1y_diad_T" description="additional pisces diagnostics" output_freq="31536000" level="5" >  
+    <file id="PISCES_1y_diad_T" description="additional pisces diagnostics" output_freq="31536000" output_level="5" >  
        <field ref="PH"       /> 
        <field ref="CO3"      />