Index: trunk/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml
===================================================================
--- trunk/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml	(revision 1650)
+++ trunk/CONFIG/ORCA2_LIM_PISCES/EXP00/iodef.xml	(revision 1679)
@@ -161,28 +161,33 @@
 
      <group id="diad_T" axis_ref="none" grid_ref="grid_T">
-       <field id="PH"          description="PH"                                       unit="-"           axis_ref="deptht" />
-       <field id="CO3"         description="Bicarbonates"                             unit="mol/L"       axis_ref="deptht" />
-       <field id="CO3sat"      description="CO3 saturation"                           unit="mol/L"       axis_ref="deptht" />
-       <field id="PAR"         description="Photosynthetically Available Radiation"   unit="W/m2"        axis_ref="deptht" />
-       <field id="PPPHY"       description="Primary production of nanophyto"          unit="mol-C/m3/s"  axis_ref="deptht" />
-       <field id="PPPHY2"      description="Primary production of diatoms"            unit="mol-C/m3/s"  axis_ref="deptht" />
-       <field id="PPNEWN"      description="New Primary production of nanophyto"      unit="mol-C/m3/s"  axis_ref="deptht" />
-       <field id="PPNEWD"      description="New Primary production of diatoms"        unit="mol-C/m3/s"  axis_ref="deptht" />
-       <field id="PBSi"        description="Primary production of Si diatoms"         unit="mol-Si/m2/s" axis_ref="deptht" />
-       <field id="PFeN"        description="Primary production of nano iron"          unit="mol-Fe/m3/s" axis_ref="deptht" />
-       <field id="PFeD"        description="Primary production of diatoms iron"       unit="mol-Fe/m3/s" axis_ref="deptht" />
+       <field id="PH"          description="PH"                                       unit="-"            axis_ref="deptht" />
+       <field id="CO3"         description="Bicarbonates"                             unit="mol/L"        axis_ref="deptht" />
+       <field id="CO3sat"      description="CO3 saturation"                           unit="mol/L"        axis_ref="deptht" />
+       <field id="PAR"         description="Photosynthetically Available Radiation"   unit="W/m2"         axis_ref="deptht" />
+       <field id="PPPHY"       description="Primary production of nanophyto"          unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="PPPHY2"      description="Primary production of diatoms"            unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="PPNEWN"      description="New Primary production of nanophyto"      unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="PPNEWD"      description="New Primary production of diatoms"        unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="PBSi"        description="Primary production of Si diatoms"         unit="mol-Si/m3/s"  axis_ref="deptht" />
+       <field id="PFeN"        description="Primary production of nano iron"          unit="mol-Fe/m3/s"  axis_ref="deptht" />
+       <field id="PFeD"        description="Primary production of diatoms iron"       unit="mol-Fe/m3/s"  axis_ref="deptht" />
+       <field id="Pcal"        description="Calcite production"                       unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="Dcal"        description="Calcite dissolution"                      unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="Graz"        description="Grazing by microzoo"                      unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="Graz2"       description="Grazing by mesozoo"                       unit="mol-C/m3/s"   axis_ref="deptht" />
+       <field id="Nfix"        description="Nitrogen fixation"                        unit="mol-N/m2/s"   axis_ref="deptht" />
+       <field id="ExpPOC"      description="POC export"                               unit="mol-C/m2/s"   axis_ref="deptht" />
+       <field id="ExpGOC"      description="GOC export"                               unit="mol-C/m2/s"   axis_ref="deptht" />
+       <field id="ExpFe1"      description="Nano iron export"                         unit="mol-Fe/m2/s"  axis_ref="deptht" />
+       <field id="ExpFe2"      description="Diatoms iron export"                      unit="mol-Fe/m2/s"  axis_ref="deptht" />
+       <field id="ExpSi"       description="Silicate export"                          unit="mol-Si/m2/s"  axis_ref="deptht" />
+       <field id="Expcal"      description="Calcite export"                           unit="mol-C/m2/s"   axis_ref="deptht" />
        <field id="Cflx"        description="DIC flux"                                 unit="mol-C/m2/s" />
        <field id="Oflx"        description="Oxygen flux"                              unit="mol-C/m2/s" />
        <field id="Kg"          description="Gas transfer"                             unit="mol-C/m2/s/uatm" />
-       <field id="DelC"        description="Delta CO2"                                unit="uatm" />
-       <field id="PMO"         description="POC export"                               unit="mol-C/m2/s" />
-       <field id="PMO2"        description="GOC export"                               unit="mol-C/m2/s" />
-       <field id="ExpFe1"      description="Nano iron export"                         unit="mol-Fe/m2/s" />
-       <field id="ExpFe2"      description="Diatoms iron export"                      unit="mol-Fe/m2/s" />
-       <field id="ExpSi"       description="Silicate export"                          unit="mol-Si/m2/s" />
-       <field id="ExpCaCO3"    description="Calcite export"                           unit="mol-C/m2/s" />
-       <field id="heup"        description="euphotic layer depth"                     unit="m" />
-       <field id="Fedep"       description="Iron deposition"                          unit="mol-Fe/m2/s" />
-       <field id="Nfix"        description="Nitrogen fixation"                        unit="mol-N/m2/s" />
+       <field id="Dpco2"       description="Delta CO2"                                unit="uatm" />
+       <field id="Dpo2"        description="Delta O2"                                 unit="uatm" />
+       <field id="Heup"        description="Euphotic layer depth"                     unit="m" />
+       <field id="Irondep"     description="Iron deposition"                          unit="mol-Fe/m2/s" />
      </group>
 
@@ -192,5 +197,5 @@
     
     <file_definition output_level="10" enabled=".TRUE.">
-      <file id="ORCA2_5d_grid_T" description="ocean T grid variables" output_freq="432000" output_level="5" >
+      <file id="ORCA2P_5d_grid_T" description="ocean T grid variables" output_freq="432000" output_level="5" >
 	<field ref="toce"         name="votemper"  />
 	<field ref="soce"         name="vosaline"  />
@@ -217,5 +222,5 @@
       </file>
       
-      <file id="ORCA2_5d_grid_U" description="ocean U grid variables" output_freq="432000" output_level="5" >
+      <file id="ORCA2P_5d_grid_U" description="ocean U grid variables" output_freq="432000" output_level="5" >
 	<field ref="uoce"         name="vozocrtx"  />
 	<field ref="uoce_eiv"     name="vozoeivu"  />
@@ -223,5 +228,5 @@
       </file>
       
-      <file id="ORCA2_5d_grid_V" description="ocean V grid variables" output_freq="432000" output_level="5" >
+      <file id="ORCA2P_5d_grid_V" description="ocean V grid variables" output_freq="432000" output_level="5" >
 	<field ref="voce"         name="vomecrty"  />
 	<field ref="voce_eiv"     name="vomeeivv"  />
@@ -229,5 +234,5 @@
       </file>
       
-      <file id="ORCA2_5d_grid_W" description="ocean W grid variables" output_freq="432000" output_level="5" >
+      <file id="ORCA2P_5d_grid_W" description="ocean W grid variables" output_freq="432000" output_level="5" >
 	<field ref="woce"         name="vovecrtz" />
 	<field ref="woce_eiv"     name="voveeivw" />
@@ -241,5 +246,5 @@
       </file>
       
-      <file id="ORCA2_5d_icemod" description="ice variables" output_freq="432000" output_level="5" >
+      <file id="ORCA2P_5d_icemod" description="ice variables" output_freq="432000" output_level="5" >
 	<field ref="ice_pres"                     />
 	<field ref="snowthic_cea" name="isnowthi" />
@@ -295,16 +300,21 @@
        <field ref="PFeN"     />
        <field ref="PFeD"     />
+       <field ref="Pcal"     />
+       <field ref="Dcal"     />
+       <field ref="Graz"     />
+       <field ref="Graz2"    />
        <field ref="Cflx"     />
-       <field ref="Oflx"     />
-       <field ref="Kg"       />
-       <field ref="DelC"     />
-       <field ref="PMO"      />
-       <field ref="PMO2"     />
+       <field ref="ExpPOC"   />
+       <field ref="ExpGOC"   />
        <field ref="ExpFe1"   />
        <field ref="ExpFe2"   />
        <field ref="ExpSi"    />
-       <field ref="ExpCaCO3" />
-       <field ref="heup"     />
-       <field ref="Fedep"    />
+       <field ref="Expcal"   />
+       <field ref="Oflx"     />
+       <field ref="Kg"       />
+       <field ref="Dpco2"    />
+       <field ref="Dpo2"     />
+       <field ref="Heup"     />
+       <field ref="Irondep"  />
        <field ref="Nfix"     />
      </file>