Index: trunk/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 1693)
+++ trunk/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 1694)
@@ -796,5 +796,5 @@
             CASE( 'U' )
                DO jj = 2, jpjm1                                   ! (U,V) ==> I
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO ji = 2, jpim1   ! NO vector opt.
                      p_taui(ji,jj) = 0.5 * ( frcv(ji-1,jj  ,jpr_itx1) + frcv(ji-1,jj-1,jpr_itx1) )
                      p_tauj(ji,jj) = 0.5 * ( frcv(ji  ,jj-1,jpr_ity1) + frcv(ji-1,jj-1,jpr_ity1) )
@@ -803,5 +803,5 @@
             CASE( 'F' )
                DO jj = 2, jpjm1                                   ! F ==> I
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO ji = 2, jpim1   ! NO vector opt.
                      p_taui(ji,jj) = frcv(ji-1,jj-1,jpr_itx1) 
                      p_tauj(ji,jj) = frcv(ji-1,jj-1,jpr_ity1)  
@@ -810,5 +810,5 @@
             CASE( 'T' )
                DO jj = 2, jpjm1                                   ! T ==> I
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO ji = 2, jpim1   ! NO vector opt.
                      p_taui(ji,jj) = 0.25 * ( frcv(ji,jj  ,jpr_itx1) + frcv(ji-1,jj  ,jpr_itx1)   &
                         &                   + frcv(ji,jj-1,jpr_itx1) + frcv(ji-1,jj-1,jpr_itx1) ) 
@@ -836,5 +836,5 @@
             CASE( 'I' )
                DO jj = 2, jpjm1                                   ! I ==> F
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO ji = 2, jpim1   ! NO vector opt.
                      p_taui(ji,jj) = frcv(ji+1,jj+1,jpr_itx1) 
                      p_tauj(ji,jj) = frcv(ji+1,jj+1,jpr_ity1)  
@@ -843,5 +843,5 @@
             CASE( 'T' )
                DO jj = 2, jpjm1                                   ! T ==> F
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO ji = 2, jpim1   ! NO vector opt.
                      p_taui(ji,jj) = 0.25 * ( frcv(ji,jj  ,jpr_itx1) + frcv(ji+1,jj  ,jpr_itx1)   &
                         &                   + frcv(ji,jj+1,jpr_itx1) + frcv(ji+1,jj+1,jpr_itx1) ) 
@@ -879,5 +879,5 @@
             CASE( 'I' )
                DO jj = 2, jpjm1                                   ! I ==> (U,V)
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO ji = 2, jpim1   ! NO vector opt.
                      p_taui(ji,jj) = 0.5 * ( frcv(ji+1,jj+1,jpr_itx1) + frcv(ji+1,jj  ,jpr_itx1) )
                      p_tauj(ji,jj) = 0.5 * ( frcv(ji+1,jj+1,jpr_ity1) + frcv(ji  ,jj+1,jpr_ity1) )
@@ -1134,5 +1134,5 @@
          !    
          !                                                  j+1   j     -----V---F
-         ! surfacz velocity always sent from T point                     !       |
+         ! surface velocity always sent from T point                     !       |
          !                                                        j      |   T   U
          !                                                               |       |
@@ -1162,5 +1162,5 @@
             CASE( 'I' )                      ! Ocean on C grid, Ice on I-point (B-grid) ==> T
                DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO ji = 2, jpim1   ! NO vector opt.
                      zotx1(ji,jj) = 0.5  * ( un(ji,jj,1)      + un(ji-1,jj  ,1) ) * zfr_l(ji,jj)  
                      zoty1(ji,jj) = 0.5  * ( vn(ji,jj,1)      + vn(ji  ,jj-1,1) ) * zfr_l(ji,jj)  
@@ -1173,5 +1173,5 @@
             CASE( 'F' )                      ! Ocean on C grid, Ice on F-point (B-grid) ==> T
                DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO ji = 2, jpim1   ! NO vector opt.
                      zotx1(ji,jj) = 0.5  * ( un(ji,jj,1)      + un(ji-1,jj  ,1) ) * zfr_l(ji,jj)  
                      zoty1(ji,jj) = 0.5  * ( vn(ji,jj,1)      + vn(ji  ,jj-1,1) ) * zfr_l(ji,jj)  
@@ -1197,5 +1197,5 @@
             CASE( 'I' )                      ! Ocean on C grid, Ice on I-point (B-grid) ==> T
                DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO ji = 2, jpim1   ! NO vector opt.
                      zotx1(ji,jj) = 0.5  * ( un(ji,jj,1)      + un(ji-1,jj  ,1) ) * zfr_l(ji,jj)   &   
                         &         + 0.25 * ( u_ice(ji+1,jj+1) + u_ice(ji,jj+1)                     &
@@ -1208,5 +1208,5 @@
             CASE( 'F' )                      ! Ocean on C grid, Ice on F-point (B-grid) ==> T
                DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                  DO ji = 2, jpim1   ! NO vector opt.
                      zotx1(ji,jj) = 0.5  * ( un(ji,jj,1)      + un(ji-1,jj  ,1) ) * zfr_l(ji,jj)   &   
                         &         + 0.25 * ( u_ice(ji-1,jj-1) + u_ice(ji,jj-1)                     &