Index: trunk/CONFIG/POMME/EXP00/iodef.xml
===================================================================
--- trunk/CONFIG/POMME/EXP00/iodef.xml	(revision 1682)
+++ trunk/CONFIG/POMME/EXP00/iodef.xml	(revision 1705)
@@ -1,7 +1,7 @@
-x<?xml version="1.0"?>
+<?xml version="1.0"?>
 
-<simulation>
+<simulation> 
   
-  <context id="nemo"> 
+  <context id="nemo">
     
     <!-- groups of variables definition -->
@@ -11,7 +11,7 @@
       <!-- T grid -->
       
-      <group id="grid_T" axis_ref="none" grid_ref="grid_T">  
+      <group id="grid_T" axis_ref="none" grid_ref="grid_T">
 	<field id="toce"         description="temperature"                               unit="degC" axis_ref="deptht"   />
-	<field id="soce"         description="salinity"                                  unit="psu"  axis_ref="deptht"   />
+       	<field id="soce"         description="salinity"                                  unit="psu"  axis_ref="deptht"   />
 	<field id="sst"          description="sea surface temperature"                   unit="degC"                     />
 	<field id="sss"          description="sea surface salinity"                      unit="psu"                      />
@@ -34,20 +34,34 @@
 	<field id="hc300"        description="Heat content 300 m"                        unit="W"                        />
      </group>
-       
+
       <!-- SBC -->
       
-      <group id="SBC" axis_ref="none" grid_ref="grid_T">
-	<field id="emp"          description="Net Upward Water Flux"                     unit="kg/m2/s"  />
-	<field id="emps"         description="concentration/dilution water flux"         unit="kg/m2/s"  />
-	<field id="qns+qsr"      description="Net Downward Heat Flux"                    unit="W/m2"     />
-	<field id="qns"          description="non solar Downward Heat Flux"              unit="W/m2"     />
-	<field id="qsr"          description="Shortwave Radiation"                       unit="W/m2"     />
-	<field id="qrp"          description="Surface Heat Flux: Damping"                unit="W/m2"     />
-	<field id="erp"          description="Surface Water Flux: Damping"               unit="Kg/m2/s"  />
+      <group id="SBC" axis_ref="none" grid_ref="grid_T" freq_op="28800">
+
+	<field id="emp"          description="Net Upward Water Flux"                                        unit="kg/m2/s"  />
+	<field id="emps"         description="concentration/dilution water flux"                            unit="kg/m2/s"  />
+	<field id="snowpre"      description="Snow precipitation"                                           unit="kg/m2/s"  />
+	<field id="runoffs"      description="River Runoffs"                                                unit="Kg/m2/s"  />
+
+	<field id="qns+qsr"      description="Net Downward Heat Flux"                                       unit="W/m2"     />
+	<field id="qns"          description="non solar Downward Heat Flux"                                 unit="W/m2"     />
+	<field id="qsr"          description="Shortwave Radiation"                                          unit="W/m2"     />
+	<field id="qrp"          description="Surface Heat Flux: Damping"                                   unit="W/m2"     />
+	<field id="erp"          description="Surface Water Flux: Damping"                                  unit="Kg/m2/s"  />
+	<field id="taum"         description="wind stress module"                                           unit="N/m2"     />
+	<field id="wspd"         description="Wind speed module at 10 m "                                   unit="m/s"      />
+	
+	<!-- *_oce variables available with ln_blk_clio or ln_blk_core -->
+	<field id="qns_oce"      description="Non solar Downward Heat Flux over open ocean"                 unit="W/m2"     />
+	<field id="qlw_oce"      description="Longwave Downward Heat Flux over open ocean"                  unit="W/m2"     />
+	<field id="qsb_oce"      description="Sensible Downward Heat Flux over open ocean"                  unit="W/m2"     />
+	<field id="qla_oce"      description="Latent Downward Heat Flux over open ocean"                    unit="W/m2"     />
+	<field id="taum_oce"     description="wind stress module over open ocean"                           unit="N/m2"     />
+
       </group>
 
       <!-- U grid -->
       
-     <group id="grid_U"  axis_ref="none" grid_ref="grid_U">
+      <group id="grid_U"  axis_ref="depthu" grid_ref="grid_U">
 	<field id="utau"        description="Wind Stress along i-axis"                  unit="N/m2" axis_ref="none" />
 	<field id="uoce"        description="ocean current along i-axis"                unit="m/s"                  />
@@ -59,7 +73,5 @@
      </group>
       
-     <!-- V grid -->
-           
-     <group id="grid_V"  axis_ref="none" grid_ref="grid_V">
+      <group id="grid_V"  axis_ref="depthv" grid_ref="grid_V">
 	<field id="vtau"        description="Wind Stress along j-axis"                  unit="N/m2" axis_ref="none" />
 	<field id="voce"        description="ocean current along j-axis"                unit="m/s"                  />
@@ -69,9 +81,9 @@
 	<!-- voce_eiv: available with key_trabbl_adv -->
 	<field id="voce_bbl"    description="BBL ocean current along j-axis"            unit="m/s"                  />
-     </group>
-           
-     <!-- W grid -->
+      </group>
       
-     <group id="grid_W"  axis_ref="depthw" grid_ref="grid_W">
+      <!-- W grid -->
+      
+      <group id="grid_W"  axis_ref="depthw" grid_ref="grid_W">
 	<field id="woce"        description="ocean vertical velocity"                   unit="m/s"                  />
 	<field id="woce_eff"    description="effective ocean vertical velocity"         unit="m/s"                  />
@@ -113,5 +125,4 @@
 	<field ref="mldr10_1"     name="somxl010"  />
 	<field ref="mldkz5"       name="somixhgt"  />
-	<field ref="ice_cover"    name="soicecov"  />
 	<field ref="qrp"          name="sohefldp"  />
 	<field ref="erp"          name="sowafldp"  />
Index: trunk/CONFIG/POMME/EXP00/namelist
===================================================================
--- trunk/CONFIG/POMME/EXP00/namelist	(revision 1682)
+++ trunk/CONFIG/POMME/EXP00/namelist	(revision 1705)
@@ -177,7 +177,9 @@
    sn_humi     = 'q2_1988'        ,       24.         , 'q2'       ,    .true.      , .false. ,   'yearly' , ''
    sn_prec     = 'precip_1988.nc' ,       -1.         , 'precip'   ,    .true.      , .false. ,   'yearly' , ''
+   sn_tdif     = 'taudif_core'    ,       24.         , 'taudif'   ,    .true.      , .true.  ,   'yearly'  ,''
 !
    cn_dir      = './'      !  root directory for the location of the bulk files
    ln_2m       = .false.   !  air temperature and humidity referenced at 2m (T) instead 10m (F)
+   ln_taudif   = .false.   !  HF tau contribution: use "mean of stress module - module of the mean stress" data ?
    rn_pfac     = 1.        !  multiplicative factor for precipitation (total & snow)
 /
@@ -194,5 +196,6 @@
 cn_snd_crt_grid   = 'T'                     ! 'T'
                                        ! receive
-cn_rcv_w10m       = 'coupled'               ! 'none' 'coupled'
+cn_rcv_w10m       = 'none'                  ! 'none' 'coupled'
+cn_rcv_taumod     = 'coupled'               ! 'none' 'coupled'
 cn_rcv_tau_nature = 'oce only'              ! 'oce only' 'oce and ice' 'mixed oce-ice'
 cn_rcv_tau_refere = 'cartesian'             ! 'spherical' 'cartesian'
@@ -555,10 +558,16 @@
    nn_etau     =   0       !  exponentially deceasing penetration of tke due to internal & intertial waves
                            !        = 0 no penetration ( O(2 km) resolution)
-                           !        = 1 additional tke source
-                           !        = 2 additional tke source applied only at the base of the mixed layer
+                           !        = 1 additional tke source (rn_efr * en)
+                           !        = 2 additional tke source (rn_efr * en) applied only at the base of the mixed layer
+                           !        = 3 additional tke source (HF contribution: mean of stress module - module of mean stress)
    nn_htau     =   1       !  type of exponential decrease of tke penetration
                            !        = 0  constant 10 m length scale
                            !        = 1  0.5m at the equator to 30m at high latitudes
-   rn_efr      =   0.05    !  fraction of surface tke value which penetrates inside the ocean
+                           !        = 2  30 meters constant depth penetration
+                           !  otion used only if nn_etau = 1 or 2: 
+   rn_efr      =   0.05    !     fraction of surface tke value which penetrates inside the ocean
+                           !  otion used only if nn_etau = 3:
+   rn_addhft   =  -1.e-3   !     add offset   applied to the "mean of stress module - module of mean stress" (always kept > 0)
+   rn_sclhft   =   1.      !     scale factor applied to the "mean of stress module - module of mean stress"
    ln_lc       = .false.   !  Langmuir cell parameterisation
    rn_lc       =   0.15    !  coef. associated to Langmuir cells